import java.io.*;
import java.util.*;

class MemoryHandler
{
ArrayList eventos;

public MemoryHandler()
{

try {
     ObjectInputStream in =  new ObjectInputStream(new 
            FileInputStream("eventos.dat"));
     eventos = ((ArrayList)in.readObject());
	      	
     in.close();
	 }
catch (Exception e)
      {  
		  
		  if ((e.getClass()).toString().equals("class java.io.FileNotFoundException"))
		        eventos = new ArrayList();
		  else  e.printStackTrace(); 
			
      }

}

public Event getEvent(fecha f)
{
Event evento = new Event(f);

for(int i = 0; i<eventos.size(); i++)
   {
	fecha fech = ((Event)(eventos.get(i))).getDate();
	if (fech.toString().equals(f.toString()))
	   {
		 evento.setDayEvent(((Event)eventos.get(i)).getDayEvent());
		 evento.setDayAlarm(((Event)eventos.get(i)).getDayAlarm());
		 evento.setColor(((Event)eventos.get(i)).getColor());
		}

	if ((((Event)eventos.get(i)).getMonthEvent() != null) && (((Event)eventos.get(i)).getDate().getDate().equals(f.getDate())))
		 {
		  evento.setMonthEvent(((Event)eventos.get(i)).getMonthEvent());
	     evento.setMonthAlarm(((Event)eventos.get(i)).getMonthAlarm());
		  evento.setColor(((Event)eventos.get(i)).getColor());
		 }

	if (((Event)eventos.get(i)).getYearEvent() != null)
	   {
	    fecha date = ((Event)eventos.get(i)).getDate();
		 if ((date.getDate()+date.getMonth()).equals(f.getDate()+f.getMonth()))
	       {
			  evento.setYearEvent(((Event)eventos.get(i)).getYearEvent());
			  evento.setYearAlarm(((Event)eventos.get(i)).getYearAlarm());
			  evento.setColor(((Event)eventos.get(i)).getColor());
			 }
		}
   }

return evento;


}


public ArrayList getAlarmEvent (fecha f)
{
ArrayList eventoList = new ArrayList();
boolean a = false;
for(int i = 0; i<eventos.size(); i++)
   {
	Event evento = new Event(((Event)(eventos.get(i))).getDate());
	Event event = (Event)eventos.get(i);
	
		
	if(event.state())
	    {
		   if ((event.getDayAlarm() != null) && ((event.getDayAlarm()).toString().equals(f.toString())))
	         {
				eventoList.add(event);
		      }
				
			if ((event.getMonthAlarm() != null) && ((event.getMonthAlarm()).getDate().equals(f.getDate())))
	         {
				eventoList.add(event);
		      }
				
			if ((event.getYearAlarm() != null) && (((event.getYearAlarm()).getDate()+(event.getYearAlarm()).getMonth()).equals(f.getDate()+f.getMonth())))
	         {
				eventoList.add(event);
		      }
      } 
   }
return eventoList;
}


public void update (Event evento)
{
boolean p = true;
for(int i = 0; i<eventos.size(); i++)
   {
Event event = (Event)eventos.get(i);


if ((evento.getDayEvent() != null) && (event.getDate().toString().equals(evento.getDate().toString())))
   {
    ((Event)eventos.get(i)).setDayEvent(evento.getDayEvent());
    ((Event)eventos.get(i)).setDayAlarm(evento.getDayAlarm());
	 ((Event)eventos.get(i)).setColor(evento.getColor());
	 p = false;
	}

if ((evento.getMonthEvent() != null) && ((event.getDate().getDate().equals(evento.getDate().getDate()))))
   {  
	 ((Event)eventos.get(i)).setMonthEvent(evento.getMonthEvent());
	 ((Event)eventos.get(i)).setMonthAlarm(evento.getMonthAlarm());
	 ((Event)eventos.get(i)).setColor(evento.getColor());
	 p = false;
   }
	
if ((evento.getYearEvent() != null) && (((event.getDate()).getDate()+(event.getDate()).getMonth()).equals(evento.getDate().getDate()+evento.getDate().getMonth())))

   {
	((Event)eventos.get(i)).setYearEvent(evento.getYearEvent());
 	((Event)eventos.get(i)).setYearAlarm(evento.getYearAlarm());
	((Event)eventos.get(i)).setColor(evento.getColor());
	p = false;
   }
}
if (p) 
   {
    eventos.add(evento);
   }
save();
}

public void save()
{
try{
    ObjectOutputStream out = new ObjectOutputStream(new 
            FileOutputStream("eventos.dat"));
    out.writeObject(eventos);
    out.close();
	}
catch (Exception e)
   {  
    e.printStackTrace(); 
   }

}

public void deleteEvent(fecha f, String s)
{

if (s == "dia")
   for(int i = 0; i<eventos.size(); i++)
   {
	fecha fech = ((Event)(eventos.get(i))).getDate();
	if (fech.toString().equals(f.toString()))
	   {
		 ((Event)eventos.get(i)).setDayEvent(null);
		 ((Event)eventos.get(i)).setDayAlarm(null);
		}
	}

if (s == "mes")
   for(int i = 0; i<eventos.size(); i++)
   {
	if ((((Event)eventos.get(i)).getMonthEvent() != null) && (((Event)eventos.get(i)).getDate().getDate().equals(f.getDate())))
		{
		((Event)eventos.get(i)).setMonthEvent(null);
		((Event)eventos.get(i)).setMonthAlarm(null);
		}
   }
	
if (s == "ano")
   for(int i = 0; i<eventos.size(); i++)
   {
	 if (((Event)eventos.get(i)).getYearEvent() != null)
	    {
	     fecha date = ((Event)eventos.get(i)).getDate();
		  if ((date.getDate()+date.getMonth()).equals(f.getDate()+f.getMonth()))
	        {    
			  ((Event)eventos.get(i)).setYearEvent(null);
			  ((Event)eventos.get(i)).setYearAlarm(null);
			  }
		 }
	 }
save();
}

}