import javax.swing.*;
import javax.swing.text.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;        
import java.io.IOException;
import java.util.ArrayList;


public class AgendaPanel extends JPanel
{
fecha hoy = new fecha();
fecha click;
int mes = Integer.valueOf(hoy.getMonth());
int ano = Integer.valueOf(hoy.getYear());
public DatePanel myPanel;
public UpdateFrame updateFrame;
MemoryHandler memory;
Document doc;
MouseListener buttonMouseListener;
AgendaFrame calendario;

public AgendaPanel(AgendaFrame cal)
 {
 memory = new MemoryHandler();
 calendario = cal;
 setLayout(new GridLayout(1,1));
 myPanel = new DatePanel(mes, ano, memory, new ButtonMouseHandler());
 setBackground (Color.white);
 add(myPanel);
 
 
 }

public void cleanTextPane()
{
try {
     doc = calendario.textPane.getDocument();
     int length = doc.getLength();
     doc.remove(0, length);
    }
catch (BadLocationException ble) 
	 {
     System.err.println("Impossible de supprimer le texte");
    } 
}

public void updateTextPane(int dia)
{
click = new fecha(dia, myPanel.mes, myPanel.ano);
Event evento = memory.getEvent(click); 
if (evento.state())
     {
	   int x = 0;
	   int y = 0;
		int dX = 360;
		int dY = 105;
		
	  
	  	   try
		   {
	       doc = calendario.textPane.getDocument();
			 cleanTextPane();
		    doc.insertString(doc.getLength(), click.toString()+ "\n\n", calendario.textPane.getStyle("bold"));
		    if (memory.getEvent(click).getDayEvent() != null)
			     doc.insertString(doc.getLength(), evento.getDayEvent()+"\n\n", calendario.textPane.getStyle("large"));
			 if (memory.getEvent(click).getMonthEvent() != null)
			    {
				  doc.insertString(doc.getLength(), evento.getMonthEvent()+"\n\n", calendario.textPane.getStyle("large"));
             }         
			 if (memory.getEvent(click).getYearEvent() != null)
			    {
				  doc.insertString(doc.getLength(), evento.getYearEvent()+"\n\n", calendario.textPane.getStyle("large"));
             }
				 
				 
			 int l = 0;
			 if (doc.getLength() > 183)
			    {
				  l = ((doc.getLength() - 183)/ 39) + 1;
				 			  
				 }
			 if (count(doc, '\n') > 6) l = l + (count(doc, '\n') - 6);
			 dY = l*20 + dY;
			 calendario.textFrame.setSize(dX, dY);
			 
			 if (calendario.getLocation().getY() > (768 - (300 + dY)))
		       {
				  x = Integer.valueOf(Long.toString(Math.round(calendario.getLocation().getX())));
		        y = Integer.valueOf(Long.toString(Math.round(calendario.getLocation().getY()-(dY+5))));
			    }
		    else
		       {
				 x = Integer.valueOf(Long.toString(Math.round(calendario.getLocation().getX())));
		        y = Integer.valueOf(Long.toString(Math.round(calendario.getLocation().getY()+280)));
			    }
		    calendario.textFrame.setLocation(x, y);
		    calendario.textFrame.show();

			 calendario.repaint();
			     
	       }
		
		catch (BadLocationException ble) 
		   {
          System.err.println("Impossible d'inserer le texte");
         } 

}
else {
      cleanTextPane();
		calendario.textFrame.hide();
	  }
}

public int count(Document d, Character c)
{
try{
String s = d.getText(0, d.getLength());

char[] ch = s.toCharArray();
int count = 0;
for (int i = 0; i<d.getLength(); i++)
    {
	 if (ch[i] == c) count++;
	 }

return count;
   }
catch(BadLocationException ble)
   {
System.err.println("Impossible de compter le nombre de character");	
	}
return -1;

}


class ButtonMouseHandler extends MouseAdapter
{

public void mouseEntered(MouseEvent e)
{
  int dia = Integer.valueOf(((javax.swing.JButton)e.getComponent()).getText());
  updateTextPane(dia);

} 

public void mouseExited (MouseEvent e)
{
cleanTextPane();
calendario.textFrame.hide();
}



public void mousePressed(MouseEvent e)
{
int dia = Integer.valueOf(((javax.swing.JButton)e.getComponent()).getText());
click = new fecha(dia, myPanel.mes, myPanel.ano);
updateFrame = new UpdateFrame (click, calendario, memory);
updateFrame.setSize(295, 290);
updateFrame.setUndecorated(true);
updateFrame.show();
}
}




}