import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

class DatePanel extends JPanel
{

MemoryHandler memory;
public int mes;
public int ano;
int numeroDia = 0;
JLabel diaLabel;
JLabel mesLabel;
JButton button;
fecha click;
String[] nombreMes = {"", "Enero", "Febrero", "Marzo", "Abril", "Mayo", "Junio", "Julio",
"Agosto", "Septiembre", "Octubre", "Noviembre", "Deciembre"};
MonthPanel firstPanel;
DayPanel secondPanel;
GridBagLayout gridbag;
GridBagConstraints c;
Color foreground = new Color(204,0,0);
Color background = Color.white;
Color color;
fecha fech;
private MouseListener currentMouseListener;

public DatePanel(int m, int a, MemoryHandler mem, MouseListener mL) 
{
super();
mes = m;
ano =a;
memory = mem;
currentMouseListener = mL;
firstPanel = new MonthPanel(true);
secondPanel = new DayPanel(true);

add(firstPanel);

add(secondPanel);
setBackground (background);
}

public DatePanel(int m, int a, Color col, fecha f, MouseListener mL)
{
super();
mes = m;
ano =a;
currentMouseListener = mL;
fech = f;
color = col;
firstPanel = new MonthPanel(false);
secondPanel = new DayPanel(false);

setBackground (background);
 
add(firstPanel);
 
add(secondPanel);

}


public void setForeground(Color col)
{
foreground = col;
}

public void setBackground(Color col)
{
background = col;
}

 public void update(boolean k)
 {
 mesLabel.setText(nombreMes[mes]+ " " + ano);
 remove(secondPanel);
 secondPanel = new DayPanel(k);
 add(secondPanel);
 repaint();
 }



class DayPanel extends JPanel
{

public DayPanel(boolean c)
{
super();
setLayout(new GridLayout(0,7));
setBackground(background);
setBorder(BorderFactory.createLineBorder(foreground));
fecha test = new fecha(1, mes, ano);
int firstDay = (test.getDay());
if (firstDay == 0) firstDay = 7;

fecha hoy = new fecha();
 
 if (mes <= 7)
    {
	  if (mes % 2 == 0) numeroDia = 30;
	  else numeroDia = 31;
	 }
 if (mes >7)
    {
	  if (mes % 2 == 0) numeroDia = 31;
	  else numeroDia = 30;
	 }
 if ((mes == 2) && ((ano % 4) == 0))
    numeroDia = 29;
 if ((mes == 2) && ((ano % 4) != 0))
    numeroDia = 28;

		

	
diaLabel = new JLabel("     Lun");
add(diaLabel);
diaLabel = new JLabel("     Mar");
add(diaLabel); 
diaLabel = new JLabel("     Mie");
add(diaLabel); 
diaLabel = new JLabel("     Jue");
add(diaLabel);
diaLabel = new JLabel("     Vie");
add(diaLabel); 
diaLabel = new JLabel("     Sab");
add(diaLabel);
diaLabel = new JLabel("     Dom");
add(diaLabel);  
	 


for (int i = 1; i < (firstDay - 1); i++)
    {
	  JLabel label = new JLabel("");
	  add(label);
	 }

for (int i = 1; i <= numeroDia; i++)
    { 
	 button = new JButton(""+i);
	 button.setForeground(foreground);
	 button.setBackground (background);
	 if ((i == Integer.valueOf(hoy.getDate())) && (mes ==Integer.valueOf(hoy.getMonth()))
	    && (ano == Integer.valueOf(hoy.getYear())))
	    {
		  
		  button.setBorder(BorderFactory.createLineBorder(foreground));
		  button.setBorderPainted(true);
		 }
	 else
	    {
		  button.setBorderPainted(false);
		 }
	click = new fecha(i, mes, ano);
	if (c)
	   {
	    Event evento = memory.getEvent(click);
       if (evento.state())
	       {
	        if (!(click.toString()).equals(hoy.toString()))
	           { 
			      button.setBorderPainted(false);
		 	      button.setBackground (evento.getColor());
					button.setForeground(new Color ((255 - (evento.getColor()).getRed()), (255 - (evento.getColor()).getGreen()), (255 - (evento.getColor()).getBlue())));
	           }
		    }
       }
	 else
	   {
		if((click.toString()).equals(fech.toString()))
		   {
			button.setBackground(color);
		   button.setForeground(new Color ((255 - color.getRed()), (255 - color.getGreen()), (255 - color.getBlue())));
		   }
		}
	 button.setFocusPainted(false);
	 
	 button.addMouseListener(currentMouseListener);
	 button.setRolloverEnabled(true);
	 add(button);
	 }
}
}




class mesButton extends JButton
{
public mesButton(String s, boolean c)
{
 super(s);
 addActionListener(new mesButtonListener(c));
 setForeground(foreground);
 setBackground (background);
 setBorderPainted(false);
 setFocusPainted(true);

}
}

class mesButtonListener implements ActionListener
{
boolean condition;

public mesButtonListener(boolean c)
{
condition = c;
}

public void actionPerformed(ActionEvent e)
{

if (e.getActionCommand() == "<<")
   {
	 mes = (mes - 1);

    if (mes == 0)
       { 
	     mes = 12;
	     ano--;
	    }
	}

if (e.getActionCommand() == ">>")
   {
	 mes = (mes + 1) % 13;
    if (mes == 0)
	    {
        ano++;
        mes = 1;
       } 
	}
		
	

update(condition);
}

}



class MonthPanel extends JPanel
{

public MonthPanel(boolean c)
{
super();
setBackground(background);
setBorder(BorderFactory.createLineBorder(foreground));

mesButton mesDecrement = new mesButton("<<" ,c);
add(mesDecrement, BorderLayout.WEST);

mesLabel = new JLabel(nombreMes[mes]+ " " + ano);
add(mesLabel, BorderLayout.CENTER);

mesButton mesIncrement = new mesButton(">>", c);
add(mesIncrement, BorderLayout.EAST);
}
}
}